// FemFindDlg.h : Header-Datei
//

#if !defined(AFX_FEMFINDDLG_H__E5605384_683F_11D3_BAC9_000021502136__INCLUDED_)
#define AFX_FEMFINDDLG_H__E5605384_683F_11D3_BAC9_000021502136__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CFemFindDlg Dialogfeld
#include <afxdao.h>
#include "ThreadSearch.h"
#include "ResizingDialog.h"
#include "UpdateDlg.h"
#include "StdAfx.h"	// Hinzugefgt von der Klassenansicht
#include "ListCtrlHelper.h"	// Hinzugefgt von der Klassenansicht
#include "Popup.h"
#include "History.h"
#include "DlgOptions.h"
#include "CPing.h"	// Hinzugefgt von der Klassenansicht

int CALLBACK SortControl(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);

class CFemFindDlg : public CResizingDialog
{
// Konstruktion
public:
	CListCtrlHelper * m_phelp;
	bool sort_order[4];
	int sort_column;
	void Test();
	~CFemFindDlg();
	CFemFindDlg(CWnd* pParent = NULL);	// Standard-Konstruktor
	LRESULT OnTrayNotification(WPARAM wParam, LPARAM lParam);
// Dialogfelddaten
	//{{AFX_DATA(CFemFindDlg)
	enum { IDD = IDD_FEMFIND_DIALOG };
	CListBox	m_lbStatus;
	CListCtrl m_lcResult;
	CString	m_minfilesize;
	CString	m_maxfilesize;
	int		m_type;
	BOOL	m_filesize;
	BOOL	m_date;
	CTime	m_datelimit;
	UINT	m_hits;
	CString	m_strQuery;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CFemFindDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	//}}AFX_VIRTUAL

// Implementierung
protected:
	bool m_searching;
	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(CFemFindDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSubmit();
	afx_msg void OnBegindragResult(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnDblclkResult(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBrowsedir();
	afx_msg void OnOpenfile();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnKillfocusMinfilesize();
	afx_msg void OnSetfocusDatelimit(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnFilesize();
	afx_msg void OnForward();
	afx_msg void OnRewind();
	afx_msg void OnDate();
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	afx_msg void OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	afx_msg void OnSelchangeSearchstring();
	afx_msg bool OnOptions();
	afx_msg void OnEditchangeSearchstring();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnDateiSuchergebnisspeichern();
	afx_msg void OnSysKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnCancel();
	afx_msg void OnTraypopupCancel();
	afx_msg void OnTraypopupOpen();
	afx_msg void OnHilfeIndex();
	afx_msg void OnHilfeInfo();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnDateiBeenden();
	afx_msg void OnSelchangeResult(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void UpdateCaption();
	CPing m_ping;
	BOOL m_visible;
	WINDOWPLACEMENT m_wplacement;
	void RelocateGripper();
	CScrollBar m_Grip;
	CDlgOptions *m_opt;
	BOOL MakeSearchString(CString & string, CString &substr);
	void SubstituteModifiers(CString & string);
	void SetResultTabs();
	
	SEARCH_STATE m_search_state;
	HINSTANCE m_instance;
	HICON m_hIcon;
	DATABASE m_database;
	CHistory * m_history;
	CPopup popup;
	CImageList * m_images;
	CThreadSearch * m_pThread;
	CSystemTray m_TrayIcon;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_FEMFINDDLG_H__E5605384_683F_11D3_BAC9_000021502136__INCLUDED_)
