// Popup.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "FemFind.h"
#include "Popup.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CPopup 


CPopup::CPopup(CWnd* pParent /*=NULL*/)
	: CDialog(CPopup::IDD, pParent)
{
	m_pIMenu = NULL;
	//{{AFX_DATA_INIT(CPopup)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
}


void CPopup::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPopup)
		// HINWEIS: Der Klassen-Assistent fgt hier DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPopup, CDialog)
	//{{AFX_MSG_MAP(CPopup)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CPopup 


// check file existance.
BOOL CPopup::FileExists( CString & filename )
{
	HANDLE file_handle;
	file_handle = CreateFile( filename, GENERIC_READ, FILE_SHARE_READ, 
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ); 
	
	if ( file_handle == INVALID_HANDLE_VALUE )
		return FALSE;
	
	CloseHandle( file_handle );
	return TRUE;
}

// split a file spec into directory and filename.
// It's not very bright, it just splits at the rightmost '\'
void CPopup::SplitPath( const CString &FullPath, CString &Path, CString &FileName )
{
	int pos;
	
	FileName.Empty();
	Path.Empty();
	pos = FullPath.ReverseFind( '\\' );
	if ( pos > 0 )
	{
		FileName = FullPath.Right( FullPath.GetLength() - pos -1 );
		Path = FullPath.Left( pos  );
	}
}

// free a pidl using the shell's malloc interface.
void CPopup::FreePidl( LPITEMIDLIST pidl )
{
	if ( pidl == NULL )
		return;
	
	LPMALLOC lpMalloc;
	if (FAILED( SHGetMalloc( &lpMalloc ) ) )
		return;
	lpMalloc->Free( pidl );
	lpMalloc->Release();
}

// helper function to step through item lists.
LPITEMIDLIST CPopup::GetNextItemID(LPITEMIDLIST pidl) 
{ 
    // Get the size of the specified item identifier. 
    int cb = pidl->mkid.cb; 
	
    // If the size is zero, it is the end of the list. 
    if (cb == 0) 
        return NULL; 
	
    // Add cb to pidl (casting to increment by bytes). 
    pidl = (LPITEMIDLIST) (((LPBYTE) pidl) + cb); 
	
    // Return NULL if it is null-terminating or a pidl otherwise. 
    return (pidl->mkid.cb == 0) ? NULL : pidl; 
} 

// CopyItemID - creates an item identifier list containing the first 
//     item identifier in the specified list. 
// Returns a PIDL if successful or NULL if out of memory. 
LPITEMIDLIST CPopup::CopyItemID(LPITEMIDLIST pidl) 
{ 
	LPMALLOC pMalloc;
	
	if ( FAILED( SHGetMalloc( &pMalloc ) ) )
		return NULL;
	
	// Get the size of the specified item identifier. 
	int cb = pidl->mkid.cb; 
	
	// Allocate a new item identifier list. 
	LPITEMIDLIST pidlNew = (LPITEMIDLIST) pMalloc->Alloc( cb + sizeof(USHORT) ); 
	if (pidlNew != NULL) 
		
	{
		// Copy the specified item identifier. 
		CopyMemory(pidlNew, pidl, cb); 
		
		// Append a terminating zero. 
		*((USHORT *) (((LPBYTE) pidlNew) + cb)) = 0; 
	}
	
	pMalloc->Release();
	
	return pidlNew; 
} 

// return an IShellFolder given a pidl to the directory.
LPSHELLFOLDER CPopup::GetIShellFolder( const LPITEMIDLIST pDirPidl )
{
	LPSHELLFOLDER pFolder;
	LPITEMIDLIST  pidl;
	LPMALLOC      pMalloc;
	
	if ( pDirPidl == NULL )
		return NULL;
	
	if ( FAILED( SHGetDesktopFolder( &pFolder ) ) )
		return NULL;
	
	if ( FAILED( SHGetMalloc( &pMalloc ) ) )
	{
		pFolder->Release();
		return NULL;
	}
	
	// step thru the pidl, binding to each subdirectory in turn.
	// Process each item identifier in the list. 
	for (pidl = pDirPidl; pidl != NULL; pidl = GetNextItemID(pidl) ) 
	{ 
		LPSHELLFOLDER pSubFolder; 
		LPITEMIDLIST pidlCopy; 
		
		// Copy the item identifier to a list by itself. 
		if ((pidlCopy = CopyItemID(pidl)) == NULL) 
			break; 
		
		// Bind to the subfolder. 
		if (!SUCCEEDED(pFolder->BindToObject( 
			pidlCopy, NULL, 
			IID_IShellFolder, (void**)&pSubFolder))) 
	       { 
			pMalloc->Free( pidlCopy); 
			pFolder->Release();
			pFolder = NULL;
			break; 
	       } 
		
		// Free the copy of the item identifier. 
		pMalloc->Free( pidlCopy); 
		
		// Release the parent folder and point to the 
		// subfolder. 
		pFolder->Release(); 
		pFolder = pSubFolder; 
	}
	
	if ( pMalloc )
		pMalloc->Release();
	
	// return  the last folder that was bound to. 
	return pFolder;
}

// return an IShellFolder interface or null given the directory.
LPSHELLFOLDER CPopup::GetIShellFolder( const char *pDirName )
{
	LPSHELLFOLDER pFolder = NULL;
	LPITEMIDLIST  DirPidl = NULL;
	LPMALLOC      pMalloc = NULL;
	ULONG eaten, attribs;
	USHORT wsz[ MAX_PATH ];
	
	// setup a shell malloc pointer for the helper funcs.
	if ( FAILED( SHGetMalloc( &pMalloc ) ) ) 
		return NULL;
	
	
	// the desktop folder.
	if (FAILED(SHGetDesktopFolder(&pFolder))) 
	{
		pMalloc->Release();
		return NULL;
	}
	
	// Ensure that the string is Unicode. 
	MultiByteToWideChar(CP_ACP, 0, pDirName, -1, wsz, MAX_PATH); 
	
	// this should return a pidl to that directory.
	if ( FAILED( pFolder->ParseDisplayName( NULL, 0, wsz, &eaten, &DirPidl, &attribs ) ) )
	{
		pFolder->Release();
		pMalloc->Release();
		return NULL;
	}
	// done with the desktop folder.
	pFolder->Release();
	
	// get the folder we really want.
	pFolder = GetIShellFolder( DirPidl );
	
	// clean up
	pMalloc->Free( DirPidl );
	pMalloc->Release();
	
	
	// return  the folder. 
	return pFolder;
	
}

//
// show the menu.
//
int CPopup::ShowContextMenu( HWND hWnd, CString &FullPath, CWnd *wnd, int x, int y )
{
	HRESULT		 hres; 
	
	LPSHELLFOLDER	 pFolder = NULL;
	LPCONTEXTMENU	 pMenu   = NULL;
	USHORT		 szWide[ MAX_PATH ];
	LPCITEMIDLIST	 FilePidl = NULL;
	ULONG		 eaten, attribs;
	CMenu		 ItemMenu;
	CString		 FileName;
	CString		 Path;
	CRect		 WindRect;
	unsigned int		 CmdId;
	int retval = 0;
	
	// split passed file spec into pathe and filename.
 	SplitPath( FullPath, Path, FileName );
	
	// make sure the passed name exists.
	if ( !FileName.IsEmpty() && !FileExists( FullPath ) )
		goto FuncExit;
	
	// init the menu
	if ( ! ItemMenu.CreatePopupMenu() ) 
		goto FuncExit;
	
	// Get the IShellFolder interface for the directory.
	pFolder = GetIShellFolder( Path );
	
	if ( !pFolder )
		goto FuncExit;
	
	// convert filename to a pidl
	MultiByteToWideChar(CP_ACP, 0, FileName, -1, szWide, MAX_PATH); 

	hres = pFolder->ParseDisplayName( NULL, 0, szWide, &eaten, (ITEMIDLIST**)&FilePidl, &attribs );
	if ( FAILED( hres ) )
		goto FuncExit;

	// get the context menu interface for the file.
	hres = pFolder->GetUIObjectOf( hWnd, 1, &FilePidl, IID_IContextMenu, 0, (LPVOID *)&pMenu);
	if ( FAILED( hres ) ) 
		goto FuncExit;
	
	// get the context menu 2 interface for the file.
	hres = pMenu->QueryInterface( IID_IContextMenu2, (LPVOID*)&m_pIMenu );
	if ( FAILED( hres ) ) 
		goto FuncExit;
	
	//  attach the context menu to our CMenu.
	hres = m_pIMenu->QueryContextMenu( ItemMenu.GetSafeHmenu(), 0, 1, 0x7000, CMF_NORMAL);
	if ( FAILED(hres) ) 
		goto FuncExit;
	
	// run the menu.
	wnd->GetWindowRect( WindRect );
	
	unsigned int id_browse;
	BOOL insert_ok;

	ItemMenu.AppendMenu(MF_SEPARATOR);
	insert_ok = AppendMenu(&ItemMenu, "Verzeichnis browsen", id_browse);

	CmdId = ItemMenu.TrackPopupMenu(TPM_LEFTALIGN | TPM_RETURNCMD | TPM_RIGHTBUTTON, 
									x, y, wnd );
	if (CmdId)
	{
		if (insert_ok && CmdId == id_browse)
		{
			retval = CMD_BROWSE_DIR;
			goto FuncExit;
		}

		// invoke the command.
		CMINVOKECOMMANDINFO cmi;
		
		cmi.cbSize = sizeof(CMINVOKECOMMANDINFO);
		cmi.fMask  = 0;
		cmi.hwnd   = hWnd;
		cmi.lpVerb = MAKEINTRESOURCE(CmdId-1);
		cmi.lpParameters = NULL;
		cmi.lpDirectory  = NULL;
		cmi.nShow        = SW_SHOWNORMAL;
		cmi.dwHotKey     = 0;
		cmi.hIcon        = NULL;
		
		hres = m_pIMenu->InvokeCommand( &cmi );
	}
	
FuncExit:
	// clean up
	ItemMenu.DestroyMenu();
	
	if ( pMenu )
		pMenu->Release();
	
	if ( pFolder )
		pFolder->Release();
	
	FreePidl( (LPITEMIDLIST)FilePidl );
	
	if ( m_pIMenu )
	{
		m_pIMenu->Release();
		m_pIMenu = NULL;
	}
	return retval;
}

BOOL CPopup::AppendMenu(CMenu *menu, CString entry, unsigned int &id)
{
	BOOL inserted = FALSE;
	CMap <unsigned int, unsigned int, BOOL, BOOL> popmap;
	
	for (unsigned int i = 0; i < menu->GetMenuItemCount(); i++)
		popmap.SetAt(menu->GetMenuItemID(i), TRUE);
	
	id = 1;
	while (!inserted && id < 65535)
	{
		if (id == 192)
			id++;
		else
			if (popmap.Lookup(id, inserted))
				inserted = TRUE;
			else
				id++;
	}
	return menu->AppendMenu(MF_STRING, id, entry);
}
